/* callback.c
**
**    Copyright (C) 2006  Wei Lian      <lianwei2003.student@sina.com>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License Version 2 as
**    published by the Free Software Foundation;
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/



#include "header.h"

void
on_clist_channel_select_row (GtkWidget * clist,
			     gint row,
			     gint column, GdkEventButton * event,
			     gpointer data)
{
  if (event->type == GDK_2BUTTON_PRESS)
    {
      char *line;
      fork_kill_play ();
      fork_kill_sop ();
      if (row >= 0)
	{
	  gtk_clist_get_text (GTK_CLIST (clist), row, 8, &line);
	  fork_sop (line);

	  gtk_clist_get_text (GTK_CLIST (clist), row, 1, &line);
	  strcpy (title, line);
	  start_play ();
	}
    }
}



void
on_button_sopcast_clicked ()
{
  char *line;

  fork_kill_play ();
  fork_kill_sop ();
  int row_select = GTK_CLIST (clist_channel)->focus_row;
  if (row_select >= 0)
    {
      gtk_clist_get_text (GTK_CLIST (clist_channel), row_select, 8, &line);
      fork_sop (line);

      gtk_clist_get_text (GTK_CLIST (clist_channel), row_select, 1, &line);
      strcpy (title, line);
      start_play ();
    }
  else
    {
      fork_play ("mms://mplay.donga.com/bbc");
    }
}



void
on_button_player_clicked ()
{
  fork_kill_play ();
  start_play ();

}


void
on_button_channel_toggled (GtkWidget * widget, gpointer data)
{
  if ((GTK_TOGGLE_BUTTON (widget)->active) && pid_channel == -2)
    get_channel_list (1);
  if ((!(GTK_TOGGLE_BUTTON (widget)->active)) && (pid_channel != -2))
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
}


void
on_button_stop_clicked ()
{
  fork_kill_play ();
  fork_kill_sop ();
}


void
on_button_exit_clicked ()
{

  fork_kill_play ();
  fork_kill_sop ();
  if (kill ((pid_t) pid_channel, SIGINT) == -1)
    kill ((pid_t) pid_channel, SIGKILL);
  gtk_main_quit ();
}


void
on_window1_destroy ()
{
  fork_kill_play ();
  fork_kill_sop ();
  if (kill ((pid_t) pid_channel, SIGINT) == -1)
    kill ((pid_t) pid_channel, SIGKILL);
  gtk_main_quit ();

}



void
on_adj_sound_change_value (GtkAdjustment * adj)
{
  sound_write ((int) adj->value);
}



void
on_button_save_clicked ()
{
  char *data_path;
  data_path =
    malloc (strlen (getenv ("HOME")) + strlen ("/.gtk-sopcast/config") + 1);
  strcpy (data_path, getenv ("HOME"));
  strcat (data_path, "/.gtk-sopcast/");
  if (access (data_path, F_OK))
    mkdir (data_path, S_IRWXU);
  strcat (data_path, "config");

  FILE *fp = fopen (data_path, "w");
  if (fp == NULL)
    {
      fprintf (stderr, "\nCan not open the file: config \n");
      return;
    }
  free (data_path);

  const gchar *line;
  ////player
  line = gtk_entry_get_text (GTK_ENTRY (entry_player));
  if (fwrite (line, strlen (line), 1, fp) == 0)
    { fclose (fp);
      fprintf (stderr, "\nCan not write the line 1 of file: config \n");
      return;
    }
  if (fwrite ("\n", 1, 1, fp) == 0)
    { fclose (fp);
      fprintf (stderr, "\nCan not write the file: config \n");
      return;
    }
  ///channels_url_header
  line = gtk_entry_get_text (GTK_ENTRY (entry_url_header));
   strcpy (channels_url_header, line);
  if (fwrite (line, strlen (line), 1, fp) == 0)
    {fclose (fp);
      fprintf (stderr, "\nCan not write the line 2 of file: config \n");
      return;
    }
if (fwrite ("\n", 1, 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the end of line: config \n");
      return;
    }
  ///channels_url
  line = gtk_entry_get_text (GTK_ENTRY (entry_url));
  strcpy (channels_url, line);
  if (fwrite (line, strlen (line), 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the line 3 of file: config \n");
      return;
    }
  if (fwrite ("\n", 1, 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the end of line: config \n");
      return;
    }
  ///record_dir
  line = gtk_entry_get_text (GTK_ENTRY (entry_record_dir));
  strcpy (record_dir, line);
  if (fwrite (line, strlen (line), 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the line 4 of file: config \n");
      return;
    }
  if (fwrite ("\n", 1, 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the end of line: config \n");
      return;
    }
  ///store win size
  int width, height;
  char str_wid[8], str_hei[8];
  gtk_window_get_size (GTK_WINDOW (window1), &width, &height);
  sprintf (str_wid, "%d", width);
  sprintf (str_hei, "%d", height);
  if (fwrite (str_wid, strlen (str_wid), 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the line 4 of file: config \n");
      return;
    }
  if (fwrite ("\n", 1, 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the end of line: config \n");
      return;
    }
  if (fwrite (str_hei, strlen (str_hei), 1, fp) == 0)
    {
      fclose (fp);
      fprintf (stderr, "\nCan not write the line 4 of file: config \n");
      return;
    }
  
  fclose (fp);
}



void
on_button_record_clicked (GtkWidget * widget, gpointer data)
{

  if (strcmp (gtk_button_get_label (GTK_BUTTON (widget)), "Record") == 0)
    {
      gtk_button_set_label (GTK_BUTTON (widget), "|Quit|");
    }
  else if (strcmp (gtk_button_get_label (GTK_BUTTON (widget)), "|Quit|") == 0)
    {
      gtk_button_set_label (GTK_BUTTON (widget), "Record");
    }
}
